/*
    loop.h
	header file for timeLoop
    
    Copyright 2003 - 2004 Night Productions, by Michael A. Nickerson (aka Darkshadow).  All rights reserved.
    Licensed under the Open Software License version 2.0
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <sys/types.h>
#include "config.h"

#ifdef HAVE_UNISTD_H
    #include <unistd.h>
#endif

#ifdef TIME_WITH_SYS_TIME
    #include <sys/time.h>
    #include <time.h>
#else
    #ifdef TM_IN_SYS_TIME
	#include <sys/time.h>
    #else
	#include <time.h>
    #endif
#endif

#define SystemTabsDef		0
#define UserTabsDef		1
#define systemCrontabFileDef    "/etc/crontab"
#define userCrontabDirectoryDef "/var/cron/tabs"
#define mailProgDef		"/usr/sbin/sendmail"
#define loopSpoolDirDef		"/var/spool/timeLoop"
#define loopSpoolFileDef	"/var/spool/timeLoop/lasttime"
#define loopLogDef		"/var/log/timeLoop.log"
#define loopPidFileDef		"/var/run/timeLoop.pid"
/* Only used on systems without a syslog function: */
#define timeLogFileDef		"/var/log/timeLoop.system.log"

#define MAXENVVARS		1001
/*(1000 + 1 extra for terminating NULL)*/

typedef struct crontab {
   char *cron_user;
   uid_t cron_user_uid;
   gid_t cron_user_gid;
   char *cron_min;
   char *cron_hour;
   char *cron_mday;
   char *cron_month;
   char *cron_wday;
   char *cron_command;
   char *environment[MAXENVVARS];
   struct crontab *nextTab;
#ifdef HAVE_FRAMEWORKS
    int batteryFlags;
#endif
} crontab;

typedef struct cronrep {
   struct crontab *systemTab;
   struct crontab *userTab;
   time_t sysTabModDate;
   time_t userTabModDate;
} cronrep;

extern void timeLog(int, const char *, ...);
extern void timeOpenLog(const char *, int, int);
extern void timeCloseLog(void);
